#!/usr/bin/perl -w
#
#=================================
# project: Sauron DHCP import
# script:  add_pools.pl
# version: 1.0\n";
#
# Pomoci Sauronovske utilitky
# 'generatehosts' naplni pooly
# pro dynamicke prirazovani adres
# pro notebooky i pro wifi. 
#================================

$server = "dns";
$wifipool = "pool-wifi";
$notebookpool = "pool-notebooks";

$commit = "";
$commit = "--commit";

#------------------------------------------
# Zarazeni zaznamu pro notebooky do skupiny
#------------------------------------------
print "Assigning appropriate hosts to dynamic pool for notebooks (zone zcu.cz) ...\n";
$res = `/usr/local/sauron/modhosts \"$server\" \"zcu.cz\" $commit --name=\"dhcp-net[0-9]{1,3}-n[0-9]{1,3}\" --setgroup=\"$notebookpool\" <commit.pom`;
print "$res\n";

print "Assigning appropriate hosts to dynamic pool for notebooks (zone pef.zcu.cz) ...\n";
$res = `/usr/local/sauron/modhosts \"$server\" \"pef.zcu.cz\" $commit --name=\"dhcp-net[0-9]{1,3}-n[0-9]{1,3}\" --setgroup=\"$notebookpool\" <commit.pom`;
print "$res\n";

#------------------------------------------
# Pridani zaznamu pro pool notebooky
# (jde o "zapomenute" segmenty)
#------------------------------------------
#@segments = (111, 7, 17, 19, 13, 20, 46, 105, 78, 79, 35, 36, 209);
#@segments = ( 13, );
#foreach(@segments){
#  print "Creating 'forgotten' hosts for dynamic pool for notebooks (zone zcu.cz, segment $_ ...\n";
#  $res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$notebookpool\" $commit \"$server\" \"zcu.cz\" \"dhcp-net$_-n:N:\" 147.228.$_.21 5 `;
#  print "$res\n";
#}

#------------------------------------------
#zaznamy pro VPN - pouze do DNS, ne do DHCP
#------------------------------------------

print "Adding DNS records for VPN (segment 64) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"openvpn20-ra:N:\" 147.228.64.21 9 `;
print "$res\n";

print "Adding DNS records for VPN (segment 95) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"openvpn95-ra:N:\" 147.228.95.24 9 `;
print "$res\n";

print "Adding DNS records for VPN (segment 44) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"openvpn44-ra:N:\" 147.228.44.213 5 `;
print "$res\n";

print "Adding DNS records for VPN (segment 109) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"openvpn109-ra:N:\" 147.228.109.11 89 `;
print "$res\n";

print "Adding DNS records for VPN (segment 1) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"openvpn1-ra:N:\" 147.228.1.213 7 `;
print "$res\n";


#--------------------------------------------
#zaznamy pro NOCAT - pouze do DNS, ne do DHCP
#--------------------------------------------

print "Adding DNS records for NOCAT (segment 180) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"nocat180-ra:N:\" 147.228.180.50 190 `;
print "$res\n";

print "Adding DNS records for NOCAT (segment 184) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"nocat184-ra:N:\" 147.228.184.50 190 `;
print "$res\n";

print "Adding DNS records for NOCAT (segment 186) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 $commit \"$server\" \"zcu.cz\" \"nocat186-ra:N:\" 147.228.186.50 190 `;
print "$res\n";


#--------------------------------------------
#zaznamy pro WIFI - DNS i DHCP
#--------------------------------------------

print "Adding records to pool for wifi (segment 181) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam181-ra:N:\" 147.228.181.2 253 `;
print "$res\n";

print "Adding records to pool for wifi (segment 182) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam182-ra:N:\" 147.228.182.2 253 `;
print "$res\n";

print "Adding records to pool for wifi (segment 183) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam183-ra:N:\" 147.228.183.2 253 `;
print "$res\n";

print "Adding records to pool for wifi (segment 185) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam185a-ra:N:\" 147.228.185.2 125 `;
print "$res\n";

$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam185b-ra:N:\" 147.228.185.130 125 `;
print "$res\n";

print "Adding records to pool for wifi (segment 187) ...\n";
$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam187a-ra:N:\" 147.228.187.2 125 `;
print "$res\n";

$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam187b-ra:N:\" 147.228.187.130 61 `;
print "$res\n";

$res = `/usr/local/sauron/generatehosts --seqstart=1 --group=\"$wifipool\" $commit \"$server\" \"zcu.cz\" \"eduroam187c-ra:N:\" 147.228.187.194 61 `;
print "$res\n";

print "All done\n";
