#!/usr/bin/perl -w

print "\n\n";
print "=================================\n";
print " project: Sauron DNS import\n";
print " script:  prepare_import_DNS3.pl\n";
print " version: 1.0\n";
print "=================================\n\n";

#======================================================
# nastaveni skriptu - zasahy delejte pouze zde
#======================================================

# upravovany zonovy soubor DB-ZONE.NEW (vcetne pripadne cesty)
$db_zcu_cz_file = "DNS_IMPORT/DB-ZONE.NEW";

# upravovany zonovy soubor db.pef.zcu.cz
$db_pef_zcu_cz_file = "DNS_IMPORT/db.pef.zcu.cz";

# domenova jmena ktera se maji presunout ze zony pef.zcu do zony zcu.cz
@domain_names_pef = (
 "kl-cat3550-sw",
 "vc-cat3550-sw",  
 "jj-cat3550-sw",
);

# domenova jmena v zone zcu.cz ZA ktera se pridaji zaznamy z pef.zcu.cz
@domain_names_zcu = (
 "kl-cat3550-gw",
 "vc-cat3550-gw",  
 "jj-cat3550-gw",
);
# pocet radku ktere patri k odpovidajicimu zaznamu v poli domain_names
# pro soubor pef.zcu.cz
@rows_pef = (11, 4, 3);

# pocet radku ktere patri k odpovidajicimu zaznamu v poli domain_names
# pro soubor DB-ZONES.NEW

@rows_zcu = (7, 6, 12);

#======================================================
# vlastni skript
#======================================================

# kopie souboru DB-ZONE.NEW
`cp $db_zcu_cz_file $db_zcu_cz_file.temp`;
`cp $db_pef_zcu_cz_file $db_pef_zcu_cz_file.temp`;

#finalni soubor je na stejnem miste jako puvodni soubor
$out_db_zcu_cz_file = "$db_zcu_cz_file";
$out_db_pef_zcu_cz_file = "$db_pef_zcu_cz_file";


print "Searching for selected domain_names ...\n";


# vlastni prevod
modify_files();

# presun tempovych souboru na finalni misto

`mv $db_zcu_cz_file.temp $out_db_zcu_cz_file`;
`mv $db_pef_zcu_cz_file.temp $out_db_pef_zcu_cz_file`;

print "  ...completed\n";

print "\n\nEnd of script\n\n";


#======================================================
# funkce modify_files 
#======================================================

sub modify_files{


open(OUT_ZCU, ">$db_zcu_cz_file.temp");
open(IN_ZCU, "<$db_zcu_cz_file");

print OUT_ZCU "\n; zaznamy nalezene v DB-ZONE.NEW\n\n";

$lineindex=0;
while($line = <IN_ZCU>){
  $lineindex++;
  $writeorigline = 1;

  $j=0;
  foreach(@domain_names_zcu){
    # hledani jednotlivych jmen
    if ($line =~ "^$_"){
      print "  '$_,' detected in zone 'zcu.cz' in line $lineindex-",$rows_zcu[$j]+$lineindex-1,"\n";
      #zmena v souboru
      print OUT_ZCU "$line";

      for($i=0;$i < ($rows_zcu[$j] - 1);$i++){
        $line2 = <IN_ZCU>;
	print OUT_ZCU "$line2";
      } #for
     
      # ---------------------------------------------
      # pridani zaznamu z pef.zcu.cz
      # 
      open(OUT_PEF, ">$db_pef_zcu_cz_file.temp");
      open(IN_PEF, "<$db_pef_zcu_cz_file");


      $lineindex2=0;
      while($line3 = <IN_PEF>){
        $lineindex2++;
        $writeorigline2 = 1;
	
        # hledani stejneho jmena jako bylo zmeneno v IN_ZCU
        if ($line3 =~ "^$domain_names_pef[$j]"){
          print "    '$domain_names_pef[$j],' detected in zone 'pef.zcu.cz.' in line $lineindex2-",$rows_pef[$j]+$lineindex2-1,"\n";
          # z prvni radky je treba odstranit domenove jmeno
	  $line3 =~ "IN.*";
	  #print "match = '$&'";
          print OUT_ZCU "\t\t$&\n";
	  print OUT_PEF ";$line3";

          # dalsi radky staci zkopirovat
          for($i=0;$i < ($rows_pef[$j] - 1);$i++){
            $line3 = <IN_PEF>;
	    $line3 =~ "IN.*";
            print OUT_ZCU "\t\t$&\n";
	    print OUT_PEF ";$line3";
          } #for
	  $writeorigline2 = 0;
	  print "    ", $rows_pef[$j], " lines moved from zone 'pef.zcu.cz' to zone 'zcu.cz'\n";
        } #if

        if ($writeorigline2 == 1){
          print OUT_PEF $line3;
        }
      } #while
      close(IN_PEF);
      close(OUT_PEF);   

      `cp $db_pef_zcu_cz_file.temp $db_pef_zcu_cz_file`;
      # ---------------------------------------------
     
      $writeorigline = 0;
    } #if
    $j++;
  }

  if ($writeorigline == 1){
    print OUT_ZCU $line;
  }
  
}

close(OUT_ZCU);
close(IN_ZCU);

} #end of sub

