#!/usr/bin/perl -w

#---------------------------------------------------------------------------------------------
# konfigurace dokoncovaciho skriptu
#---------------------------------------------------------------------------------------------

# cesta ke konfiguraci, kterou vygeneroval Sauron 
$dhcp_cfg_path = "/var/sauron/dhcp";

#cesta k vysledne konfiguraci - cheb
$dhcp_final_path0 = "/var/sauron/dhcp-final/cheb";

#cesta k vysledne konfiguraci - hyperochus1
$dhcp_final_path1 = "/var/sauron/dhcp-final/hyper1";

#cesta k vysledne konfiguraci - hyperochus2
$dhcp_final_path2 = "/var/sauron/dhcp-final/hyper2";

#konfigurace pro hyperochus 1
$hyp1cfg = <<_EOM_;
failover peer "failover_zcu" {
  primary;
  address hyper.zcu.cz;
  port 519;                     # listen on this TCP port

  peer address hype2.zcu.cz;
  peer port 519;                # connect to peer on this port

  max-response-delay 60;        # how many seconds to wait for answer from peer
  max-unacked-updates 10;       # how often to try to contact the failover peer
  load balance max seconds 3;   # a cutoff after which load balancing is disabled

  # 	options for primary server only:
  # 	split 128;                    # load balancing threshold (should be 128)
  #     mclt 3600;                    # Maximum Client Lead Time
}  
_EOM_
						
#konfigurace pro hyperochus 2
$hyp2cfg = <<_EOM_;
failover peer "failover_zcu" {
  secondary;
  address hype2.zcu.cz;
  port 519;                     # listen on this TCP port

  peer address hyper.zcu.cz;
  peer port 519;                # connect to peer on this port

  max-response-delay 60;        # how many seconds to wait for answer from peer
  max-unacked-updates 10;       # how often to try to contact the failover peer
  load balance max seconds 3;   # a cutoff after which load balancing is disabled

  # options for primary server only:
  #  split 128;                   # load balancing threshold (should be 128)
  #  mclt 3600;                   # Maximum Client Lead Time
}
_EOM_

#---------------------------------------------------------------------------------------------
# vlastni skript 
#---------------------------------------------------------------------------------------------

print "\n\n";
print "==============================\n";
print " project: Sauron DHCP export\n";
print " script:  complete_dhcp.pl\n";
print " version: 1.0\n";
print "==============================\n\n";

print "Creating directories ...\n";
`mkdir $dhcp_final_path0`;
`mkdir $dhcp_final_path1`;
`mkdir $dhcp_final_path2`;

print "Creating configuration for Cheb ...\n";
#proste zkopirovani stavajici konfigurace
`cp $dhcp_cfg_path/dhcpd.conf $dhcp_final_path0/dhcpd.conf`;

print "Adding failover settings to all pools ...\n";
open(ORIGIN, "<$dhcp_cfg_path/dhcpd.conf");
@lines = <ORIGIN>;
@lines2 = ();
foreach(@lines){
  push @lines2, $_;
  if ($_ =~ /^[\s]*pool {\s.*/){
    push @lines2, "                failover peer \"failover_zcu\";\n"
  }
}

close(ORIGIN);


print "Creating configuration for Hyperochus 1 ...\n";
#na zacatek konfiguraku se prihodi konfigurace z $hyp1cfg + pridani radku o failoveru do poolu
open(HYP1, ">$dhcp_final_path1/dhcpd.conf");
print HYP1 $hyp1cfg;
foreach(@lines2){
  print HYP1 $_;
}
close(HYP1);

print "Creating configuration for Hyperochus 2 ...\n";
#na zacatek konfiguraku se prihodi konfigurace z $hyp2cfg + pridani radku o failoveru do poolu
open(HYP2, ">$dhcp_final_path2/dhcpd.conf");
print HYP2 $hyp2cfg;
foreach(@lines2){
  print HYP2 $_;
}
close(HYP2);

print "Completed ...\n";
