#!/usr/bin/perl -w

#---------------------------------------------------------------------------------------------
# konfigurace dokoncovaciho skriptu
#---------------------------------------------------------------------------------------------

# cesta k souborum, ktere skript "prepare_import_DNS1.pl" oznacil jako "additive"
$dns_additive_path = "/var/sauron-import/dns/DNS_ADDITIVE";

# cesta ke konfiguraci, kterou vygeneroval Sauron 
$dns_cfg_path = "/var/sauron/dns";

#cesta k vysledne konfiguraci
$dns_final_path = "/var/sauron/dns-final";

#---------------------------------------------------------------------------------------------
# vlastni skript 
#---------------------------------------------------------------------------------------------

print "\n\n";
print "==============================\n";
print " project: Sauron DNS export\n";
print " script:  complete_dns.pl\n";
print " version: 1.0\n";
print "==============================\n\n";


print "Copying files ...\n";

#------------------------------------------------------------------------
#nakopirovani souboru pro zony typu hesiod
#------------------------------------------------------------------------

`cp $dns_additive_path/db.hes.cache $dns_final_path/db.hes.cache`;
`cp $dns_additive_path/db.hesiod $dns_final_path/db.hesiod`;

# POZOR: soubor db.hesiod obsahuje odkazy do adresare \etc\athena\...
#        (soubory v tomto adresari jsou generovany jinym programem a nelze je tedy zkopirovat)


#------------------------------------------------------------------------
#nakopirovani souboru pro IPv6
#------------------------------------------------------------------------

`cp $dns_additive_path/db.localhost-ipv6 $dns_final_path/db.localhost-ipv6`;

#------------------------------------------------------------------------
# zkopirovani souboru pro zonu CHAOS
#------------------------------------------------------------------------

`cp $dns_additive_path/db.bind-version $dns_final_path/db.bind-version`;

#------------------------------------------------------------------------
# nakopirovani souboru DB-SRV a jim includovanych souboru
#------------------------------------------------------------------------
`cp $dns_additive_path/DB-SRV $dns_final_path/DB-SRV`;
`cp $dns_additive_path/db.srv-peek.krb $dns_final_path/db.srv-peek.krb`;
`cp $dns_additive_path/db.srv.krb $dns_final_path/db.srv.krb`;

#------------------------------------------------------------------------
# kopirovani souboru generovanych Sauronem
#------------------------------------------------------------------------
`cp $dns_cfg_path/*.* $dns_final_path`;

print "  ... completed\n";

#------------------------------------------------------------------------
# uprava souboru named.conf
#------------------------------------------------------------------------

print "\nModifying file '$dns_cfg_path/named.conf' ...\n";
open(ZCU_IN, "<$dns_cfg_path/named.conf");
open(ZCU_OUT, ">$dns_cfg_path/named.conf.temp");
while($line = <ZCU_IN>){
  $printline = 1;
  
  #
  # uprava 128/26 pro icgz.cas.cz
  #
  if ($line =~ "zone \"244.231.147.in-addr.arpa\" IN     {"){
    print ZCU_OUT "zone \"128/26.244.231.147.in-addr.arpa\" IN     {\n";    
    $printline = 0;
  }
 
  #
  # zmena z '// eof' na '// ADDITIVE zones'
  # 
  if ($line =~ "// eof"){
    print ZCU_OUT "//\n// ADDITIVE zones\n//\n\n\n";
    $printline = 0;
  }
 
  if ($printline == 1){
    print ZCU_OUT $line;
  }
}
close(ZCU_IN);
close(ZCU_OUT);

`mv $dns_cfg_path/named.conf.temp $dns_cfg_path/named.conf`;

#
# pridani zon ze souboru ADDITIVE/named.conf
#
`cat $dns_cfg_path/named.conf $dns_additive_path/named.conf > $dns_final_path/named.conf`;

#------------------------------------------------------------------------

print "  ... completed\n";

print "\n\nEnd of script\n\n";
