#!/usr/bin/perl -w
#
#=================================
# project: Sauron DHCP import
# script:  prepare_import_DHCP1.pl
# version: 1.1\n";
# 
# Skript spoustejici jednotlive
# kroky nutne k priprave importu.
#================================

mkdir "DHCP-COMPLET";

#prevod konfiguracniho souboru z formatu bootp do formatu dhcp
print "BOOTP 2 DHCP conversion ...\n";
`perl bootp2dhcp.pl bootp-afs/bootptab > DHCP-COMPLET/dhcp.gr.bootp`;

#likvidace skupin, ve kterych se nenachazeji zadni hosti
print "Removing groups with no hosts ...\n";
`perl remove_bad_groups.pl DHCP-COMPLET/dhcp.gr.bootp > DHCP-COMPLET/dhcp.bootp`;

#slouceni obou sdilenych konfiguraku pro zcu
print "Concatenate ZCU configuration files ...\n";
`cat dhcp-afs/dhcpd_share.conf dhcp-afs/dhcpd_share_tixdns.conf > DHCP-COMPLET/dhcp.shared.conf`;

#prevod zaznamu na viceradkove (kazdy tag je na vlastni radce) - pro jednodussi zpracovani nasledujicimi skripty
#+ likvidace komentaru
print "Multi-row conversion ...\n";
`perl make_multi_rows.pl dhcp-afs/dhcpd_cheb.conf > DHCP-COMPLET/dhcp.cheb.mr`;
`perl make_multi_rows.pl DHCP-COMPLET/dhcp.shared.conf > DHCP-COMPLET/dhcp.shared.mr`;

#prevod hostname na IP adresu
print "Hostname 2 IP number conversion ...\n";
`perl hostname2ip.pl DHCP-COMPLET/dhcp.shared.mr > DHCP-COMPLET/dhcp.shared.ip`;
`perl hostname2ip.pl DHCP-COMPLET/dhcp.cheb.mr > DHCP-COMPLET/dhcp.cheb.ip`;

#uprava skupin (groups{})
print "Modifying groups ...\n";
`perl prepare_cheb.pl DHCP-COMPLET/dhcp.cheb.ip > DHCP-COMPLET/dhcp.cheb`;
`perl modify_groups2.pl DHCP-COMPLET/dhcp.shared.ip > DHCP-COMPLET/dhcp.shared.ip2`;
`perl modify_groups2.pl DHCP-COMPLET/dhcp.shared.ip2 > DHCP-COMPLET/dhcp.zcu`;

#slouceni do jednoho importovaneho souboru
print "Concatenate do one file ...\n";
`cat DHCP-COMPLET/dhcp.zcu DHCP-COMPLET/dhcp.cheb DHCP-COMPLET/dhcp.bootp > DHCP-COMPLET/import.dhcp`;
#`cat DHCP-COMPLET/dhcp.zcu DHCP-COMPLET/dhcp.cheb> DHCP-COMPLET/import.dhcp`;

#pridani shared-network "webnet"
print "Shared-network addition ...\n";
`perl add_sharednet.pl DHCP-COMPLET/import.dhcp > DHCP-COMPLET/import1.dhcp`;

#prevod direktivy "use-host-decl-names on" na X-krat "option host-name"
print "Adding option host-name ...\n";
`perl modify_use_host_name.pl DHCP-COMPLET/import1.dhcp > DHCP-COMPLET/import2.dhcp`;

print "\nCompleted\n\n";
